CBL CICS('COBOL3,NOSEQ') APOST TRUNC(OPT)                               01000000
       IDENTIFICATION DIVISION.                                         02000000
       PROGRAM-ID.  DFH0WSSB                                            03000000
      ***************************************************************** 04000000
      *                                                               * 05000000
      * MODULE NAME = DFHWSSB                                        * 06000000
      *                                                               * 07000000
      * DESCRIPTIVE NAME = %PRODUCT (SOAP) Sample Service Requestor   * 08000000
      *                                                               * 09000000
      *  %COPYRIGHT         IBM CONFIDENTIAL                          * 10000000
      *                                                               * 11000000
      * STATUS = %ATL0                                                * 12000000
      *                                                               * 13000000
      * FUNCTION =                                                    * 14000000
      *     This module is a traditional ("green screen") application * 15000000
      *     program to demonstrate the SOAP support delivered in the  * 16000000
      *     SOAP for CICS feature.                                    * 17000000
      *                                                               * 18000000
      *                                                               * 19000000
      * NOTES :                                                       * 20000000
      *  DEPENDENCIES = S/390                                         * 21000000
      *  PATCH LABEL = Standard COBOL patch Area                      * 22000000
      *  MODULE TYPE = Executable                                     * 23000000
      *  PROCESSOR = COBOL                                            * 24000000
      *                                                               * 25000000
      *---------------------------------------------------------------* 26000000
      *                                                               * 27000000
      * CHANGE ACTIVITY :                                             * 28000000
      *      MOD(DFHWSSB),COMP(SOAP),PROD(%PRODUCT):                * 29000000
      *                                                               * 30000000
      *   PN= REASON REL YYMMDD HDXXIII : REMARKS                     * 31000000
      *  L0= 851    %AT 030519 HD2JPEH : Copy of SOAPBOX sample      * 32000000
      *                                                               * 33000000
      ***************************************************************** 34000000
                                                                        35000000
       AUTHOR.      IBM.                                                36000000
       ENVIRONMENT DIVISION.                                            37000000
       DATA DIVISION.                                                   38000000
       WORKING-STORAGE SECTION.                                         39000000
CA8J  *
CA8J  * Copy variable definitions for S4CBASIC
CA8J  *
CA8J   COPY S4CBADEF.                                                   39010000
      *                                                                 39020000
      * Data that is initialized to LOW-VALUES at start of program.     39030000
      *                                                                 39040000
       01 INITIALIZED-DATA.                                             39050000
          02 TERMINAL-DATA-POINTERS.                                    39060000
             03 URI-DATA-PTR      POINTER SYNCHRONIZED.                 39070000
             03 URI-DATA-ADDR     REDEFINES URI-DATA-PTR                39080000
                                  PIC S9(8) COMP-4 SYNCHRONIZED.        39090000
             03 TERM-DATA-INIT    POINTER SYNCHRONIZED.                 39100000
             03 TERM-DATA-PTR     POINTER SYNCHRONIZED.                 39110000
             03 TERM-DATA-ADDR    REDEFINES TERM-DATA-PTR               39120000
                                  PIC S9(8) COMP-4 SYNCHRONIZED.        39130000
             03 TERM-DATA-END     POINTER SYNCHRONIZED.                 39140000
             03 TERM-DATA-ENDA    REDEFINES TERM-DATA-END               39150000
                                  PIC S9(8) COMP-4 SYNCHRONIZED.        39160000
             03 TERM-DATA-LEN     PIC S9(4) COMP-4 SYNCHRONIZED.        39170000
                                                                        39180000
          02 BUSINESS-DATA.                                             39190000
             03 STOCK-SYMBOL      PIC XXX.                              39200000
             03 STOCK-QUOTE       PIC XXX.                              39210000
             03 STOCK-DATESTAMP   PIC X(8).                             39220000
             03 STOCK-TIMESTAMP   PIC X(8).                             39230000
                                                                        39240000
       01 PROCESS-DATA.                                                 39250000
          02 PROCESS-NAME.                                              39260000
             03 FILLER            PIC X(9)  VALUE 'SOAPHTTP-'.          39270000
             03 PROCESS-NETNAME   PIC X(8).                             39280000
             03 FILLER            PIC X     VALUE '-'.                  39290000
             03 PROCESS-TERMID    PIC X(4).                             39300000
             03 FILLER            PIC X     VALUE '-'.                  39310000
             03 PROCESS-SERIAL    PIC 9(13).                            39320000
          02 PROCESS-TYPE         PIC X(8)  VALUE 'SOAPHTTP'.           39330000
          02 PROCESS-TRANID       PIC X(4)  VALUE 'CSAC'.               39340000
          02 PROCESS-ABCODE       PIC X(4).                             39350000
          02 PROCESS-STATUS       PIC 9(8)  COMP-4 SYNCHRONIZED.        39360000
                                                                        39370000
       01 CURRENT-ABSTIME.                                              39380000
          02 FILLER               PIC X(3).                             39390000
          02 CURRENT-MILLISECONDS PIC 9(9)  COMP-3.                     39400000
                                                                        39410000
       01 DOCUMENT-PARAMETERS.                                          39420000
          02 DOCUMENT-SIZE        PIC S9(8) COMP-4 SYNCHRONIZED.        39430000
          02 DOCUMENT-PTR         POINTER SYNCHRONIZED.                 39440000
          02 DOCUMENT-TOKEN       PIC X(16).                            39450000
          02 TEMPLATE-NAME        PIC X(48) VALUE 'SOAPBOXBODY'.        39460000
          02 STOCK-SYMBOL-NAME    PIC X(32) VALUE 'stocksymbol'.        39470000
                                                                        39480000
       01 PARSER-VARIABLES.                                             39490000
          02 PARSE-ERROR          PIC X VALUE 'N'.                      39500000
          02 SOAP-FAULT           PIC X VALUE 'N'.                      39510000
          02 ELEMENT-FLAGS.                                             39520000
            03 IN-QUOTE           PIC X VALUE 'N'.                      39530000
            03 IN-DATESTAMP       PIC X VALUE 'N'.                      39540000
            03 IN-TIMESTAMP       PIC X VALUE 'N'.                      39550000
            03 FILLER             PIC X VALUE 'N'.                      39560000
            03 IN-FAULTSTRING     PIC X VALUE 'N'.                      39570000
            03 IN-DETAIL          PIC X VALUE 'N'.                      39580000
          02 TAG-SIZE             PIC S9(4) COMP-4 SYNCHRONIZED.        39590000
          02 TAG-NAME             PIC X(38).                            39600000
          02 WORKAREA             PIC X(256).                           39610000
                                                                        39620000
       01 FAULT-VARIABLES.                                              39630000
          02 FAULT-STRING         PIC X(40).                            39640000
          02 FAULT-DETAIL         PIC X(80).                            39650000
                                                                        39660000
      *                                                                 39670000
      * Miscellaneous variables.                                        39680000
      *                                                                 39690000
       77 SBA                     PIC X VALUE IS X'11'.                 39700000
       77 DFHENTER                PIC X VALUE IS ''''.                  39710000
       77 DFHCLEAR                PIC X VALUE IS '_'.                   39720000
       77 DFHPF3                  PIC X VALUE IS '3'.                   39730000
       77 DFHNULL                 PIC X VALUE IS X'00'.                 39740000
                                                                        39750000
       77 SPACE-COUNT             PIC S9(4) VALUE 0 COMP-4 SYNC.        39760000
       77 QUEUE-ITEM              PIC S9(4) VALUE 1 COMP-4 SYNC.        39770000
                                                                        39780000
       77 I                       PIC S9(8) COMP-4 SYNCHRONIZED.        39790000
       77 J                       PIC S9(8) COMP-4 SYNCHRONIZED.        39800000
       77 K                       PIC S9(8) COMP-4 SYNCHRONIZED.        39810000
       77 L                       PIC S9(8) COMP-4 SYNCHRONIZED.        39820000
                                                                        39830000
      *                                                                 39840000
      * BMS logical map definitions for DFH0SBM (SBOXMAP) mapset.       39850000
      *                                                                 39860000
       COPY DFH0SBMO.                                                   39870000
      *                                                                 39880000
      * Web-services constants.                                         39890000
      *                                                                 39900000
       COPY DFHWSCNO.                                                   39910000
      *                                                                 39920000
      * DFHWBCLI parameter list                                         39930000
      *                                                                 39940000
       COPY DFHWBCLO.                                                   39960000
                                                                        39980000
      ***************************************************************** 40000000
       LINKAGE SECTION.                                                 41000000
      *                                                                 41020000
      * State data (preserved in commarea and in TSQUEUE SOAPBUBBLE)    41040000
      *                                                                 41060000
       01 STATE-DATA REDEFINES DFHCOMMAREA.                             41080000
          02 SCREEN-HEIGHT        PIC S9(4) COMP-4 SYNCHRONIZED.        41100000
          02 SCREEN-WIDTH         PIC S9(4) COMP-4 SYNCHRONIZED.        41130000
          02 URI-LEN              PIC S9(8) COMP-4 SYNCHRONIZED.        41160000
          02 PROXY-LEN            PIC S9(8) COMP-4 SYNCHRONIZED.        41190000
          02 FILLER               PIC S9(8) COMP-4 SYNCHRONIZED.        41220000
          02 CURRENT-URI          PIC X(256).                           41250000
          02 CURRENT-PROXY        PIC X(256).                           41280000
                                                                        41310000
      *                                                                 41340000
      * Variable length areas that need to be accessed by character.    41370000
      *                                                                 41400000
       01 TERMINAL-DATA.                                                41430000
          02 TERMINAL-CHAR        PIC X OCCURS 1 TO 4096                41460000
                                      DEPENDING ON TERM-DATA-LEN.       41490000
       01 URI-DATA.                                                     41520000
          02 URI-CHAR             PIC X OCCURS 1 TO 1024                41550000
                                      DEPENDING ON URI-LEN.             41580000
                                                                        41610000
       01 PROXY-DATA.                                                   41640000
          02 PROXY-CHAR           PIC X OCCURS 1 TO 1024                41670000
                                      DEPENDING ON PROXY-LEN.           41700000
                                                                        41730000
       01 SOAP-REQUEST-BODY.                                            41760000
          02 FILLER               PIC X OCCURS 1 TO 16777215            41790000
                                      DEPENDING ON DOCUMENT-SIZE.       41820000
                                                                        41850000
       01 SOAP-RESPONSE-BODY.                                           41880000
          02 FILLER               PIC X OCCURS 1 TO 16777215            41910000
                                      DEPENDING ON DOCUMENT-SIZE.       41940000
      ***************************************************************** 42000000
       PROCEDURE DIVISION.                                              43000000
      *                                                                 44000000
      * Overall logic:                                                  45000000
      *  o Initialize working storage.                                  46000000
      *  o Check for presence of commarea. If no commarea:              48000000
      *    - Getmain and initialize storage for commarea                50000000
      *    - Read the SOAPBUBBLE temporary storage queue to obtain      52000000
      *      permanent state data (the target URI and the optional      54000000
      *      proxy server address).                                     56000000
      *    - If the TSQ entry doesn't exist, initialize it with blanks. 58000000
      *  o Display the details in map SBOXM01                           60000000
      *  o When a URI and stock symbol have been entered:               62000000
      *    - Create a process id                                        64000000
      *    - Put the target URI into container TARGET-URI               66000000
      *    - If a proxy URI was entered, save in container PROXY-SERVER 68000000
      *    - Create a Document Domain document                          70000000
      *    - Insert the stock symbol as a document symbol               72000000
      *    - Retrieve the completed document and store in               74000000
      *      container REQUEST-BODY                                     76000000
      *    - Schedule the CICS SOAP pipeline manager                    78000000
      *    - Retrieve the SOAP response body from the OUTPUT container  80000000
      *    - Parse the response body to obtain the quote value          82000000
      *      (or a SOAP fault)                                          84000000
      *    - Display the quotation value or messages from FAULT.        86000000
      *  o If any state data has been overtyped, update the TS queue    88000000
      *                                                                 90000000
      ***************************************************************** 92000000
       MAINLINE SECTION.                                                94000000
           MOVE LOW-VALUES TO INITIALIZED-DATA.                         94010000
           IF EIBCALEN IS ZERO THEN PERFORM INITIAL-RECEIVE             94020000
           ELSE PERFORM CONTINUE-CONVERSATION                           94030000
                PERFORM BUILD-SOAP-REQUEST-BODY                         94040000
                PERFORM SCHEDULE-SOAP-PIPELINE                          94050000
                PERFORM PARSE-SOAP-RESPONSE-BODY                        94060000
           END-IF.                                                      94070000
           PERFORM SEND-MAP-AND-EXIT.                                   94080000
                                                                        94090000
      *                                                                 94100000
      * Process initial transaction in pseudo-conversation,             94110000
      * when no commarea is received.                                   94120000
      *                                                                 94130000
       INITIAL-RECEIVE.                                                 94140000
           MOVE LOW-VALUES TO SBOXM01I.                                 94150000
                                                                        94160000
           EXEC CICS GETMAIN SET(ADDRESS OF DFHCOMMAREA)                94170000
                             FLENGTH(LENGTH OF STATE-DATA)              94180000
                             END-EXEC.                                  94190000
                                                                        94200000
      * Check whether there is any permanent state data from            94210000
      * earlier invocations of this transaction                         94220000
                                                                        94230000
           EXEC CICS READQ TS QNAME('SOAPBUBBLE')                       94240000
                              ITEM(QUEUE-ITEM)                          94250000
                              INTO(STATE-DATA)                          94260000
                              NOHANDLE END-EXEC.                        94270000
                                                                        94280000
           IF EIBRESP NOT EQUAL DFHRESP(NORMAL)                         94290000
              MOVE SPACES TO STATE-DATA                                 94300000
              MOVE ZEROS TO URI-LEN PROXY-LEN                           94310000
                            SCREEN-HEIGHT SCREEN-WIDTH                  94320000
              EXEC CICS WRITEQ TS QNAME('SOAPBUBBLE') MAIN              94330000
                                  FROM(STATE-DATA)                      94340000
                                  END-EXEC.                             94350000
                                                                        94360000
      * Get current screen size                                         94370000
                                                                        94380000
           EXEC CICS ASSIGN SCRNHT(SCREEN-HEIGHT)                       94390000
                            SCRNWD(SCREEN-WIDTH)                        94400000
                            NOHANDLE                                    94410000
                            END-EXEC.                                   94420000
                                                                        94430000
      * Receive initial transaction command line                        94440000
                                                                        94450000
           EXEC CICS RECEIVE SET    (TERM-DATA-INIT)                    94460000
                             LENGTH (TERM-DATA-LEN)                     94470000
                             NOHANDLE                                   94480000
                             END-EXEC.                                  94490000
                                                                        94500000
      * If there is any data following the transaction ID               94510000
      * (after one or more spaces) set a pointer to it.                 94520000
                                                                        94530000
           SET TERM-DATA-PTR TO TERM-DATA-INIT.                         94540000
           SET ADDRESS OF TERMINAL-DATA TO TERM-DATA-PTR.               94550000
           SET TERM-DATA-END TO ADDRESS OF                              94560000
                                TERMINAL-CHAR(TERM-DATA-LEN + 1).       94570000
           IF TERMINAL-CHAR(1) EQUAL SBA THEN                           94580000
              SET ADDRESS OF TERMINAL-DATA                              94590000
               TO ADDRESS OF TERMINAL-CHAR(4).                          94600000
                                                                        94610000
           PERFORM BUMP-ADDRESS TEST AFTER                              94620000
                   UNTIL TERM-DATA-ADDR >= TERM-DATA-ENDA               94630000
                      OR TERMINAL-CHAR(1) EQUAL SPACE.                  94640000
           IF TERM-DATA-ADDR < TERM-DATA-ENDA THEN                      94650000
           PERFORM BUMP-ADDRESS TEST AFTER                              94660000
                   UNTIL TERM-DATA-ADDR >= TERM-DATA-ENDA               94670000
                      OR TERMINAL-CHAR(1) NOT EQUAL SPACE.              94680000
                                                                        94690000
      *                                                                 94700000
      * If the command buffer contains data after the transaction       94710000
      * identifier, assume it is the target URI and copy it into        94720000
      * the commarea. Otherwise, leave the commarea alone as it         94730000
      * may contain the URI from the previous invocation of SBOX.       94740000
      *                                                                 94750000
           SET URI-DATA-PTR TO ADDRESS OF TERMINAL-DATA.                94760000
           SET ADDRESS OF URI-DATA TO URI-DATA-PTR.                     94770000
           COMPUTE L = TERM-DATA-ENDA - URI-DATA-ADDR.                  94780000
           IF L < 0   THEN MOVE 0   TO L.                               94790000
           IF L > 256 THEN MOVE 256 TO L.                               94800000
                                                                        94810000
           IF L > ZERO THEN                                             94820000
             MOVE L TO URI-LEN                                          94830000
             MOVE SPACES TO CURRENT-URI                                 94840000
             MOVE URI-DATA TO CURRENT-URI.                              94850000
                                                                        94860000
      *                                                                 94870000
      * Link to the CICS Web Client Utility program to determine        94880000
      * the default proxy URL.                                          94890000
      *                                                                 94900000
           MOVE LOW-VALUES TO DFHWBCLI-ARG.                             94910000
           MOVE WBCLI-VERSION-CURRENT TO WBCLI-VERSION-NO.              94920000
           MOVE WBCLI-FUNCTION-INQUIRE-PROXY TO WBCLI-FUNCTION.         94930000
           EXEC CICS LINK PROGRAM('DFHWBCLI')                           94940000
                          COMMAREA(DFHWBCLI-ARG)                        94950000
                          LENGTH(LENGTH OF DFHWBCLI-ARG)                94960000
           END-EXEC.                                                    94970000
           IF WBCLI-RESPONSE EQUAL WBCLI-RESPONSE-OK THEN               94980000
              SET ADDRESS OF PROXY-DATA TO WBCLI-PROXY-URL-PTR          94990000
              MOVE WBCLI-PROXY-URL-LEN TO PROXY-LEN                     95000000
              MOVE PROXY-DATA TO CURRENT-PROXY                          95010000
           END-IF.                                                      95020000
                                                                        95030000
                                                                        95040000
      * Save the commarea in the SOAPBUBBLE queue so that it will       95050000
      * persist even after the pseudo-conversation has ended.           95060000
                                                                        95070000
           PERFORM SAVE-COMMAREA-IN-TSQUEUE.                            95080000
                                                                        95090000
      *                                                                 95100000
      * Continue the pseudo-conversation when data from a previous      95110000
      * instance of the transaction is received in the commarea.        95120000
      *                                                                 95130000
       CONTINUE-CONVERSATION.                                           95140000
           EXEC CICS RECEIVE SET    (TERM-DATA-INIT)                    95150000
                             LENGTH (TERM-DATA-LEN)                     95160000
                             NOHANDLE                                   95170000
                             END-EXEC.                                  95180000
           IF EIBAID = DFHCLEAR OR                                      95190000
              EIBAID = DFHPF3   THEN PERFORM CLEAR-SCREEN-AND-EXIT.     95200000
                                                                        95210000
           SET TERM-DATA-PTR TO TERM-DATA-INIT.                         95220000
           SET ADDRESS OF TERMINAL-DATA TO TERM-DATA-PTR.               95230000
           SET TERM-DATA-END TO ADDRESS OF                              95240000
                                TERMINAL-CHAR(TERM-DATA-LEN + 1).       95250000
                                                                        95260000
           SET ADDRESS OF TERMINAL-DATA TO TERM-DATA-INIT.              95270000
           EXEC CICS RECEIVE MAP('SBOXM01') MAPSET('DFH0SBM')           95280000
                             MAPPINGDEV(EIBTRMID) FROM(TERMINAL-DATA)   95290000
                             NOHANDLE                                   95300000
                             END-EXEC.                                  95310000
                                                                        95320000
           IF URIL > 0 THEN                                             95330000
              MOVE URII TO CURRENT-URI                                  95340000
              MOVE ZERO TO SPACE-COUNT                                  95350000
              INSPECT CURRENT-URI TALLYING SPACE-COUNT FOR ALL SPACES   95360000
              SUBTRACT SPACE-COUNT FROM LENGTH OF CURRENT-URI           95370000
                       GIVING URI-LEN.                                  95380000
                                                                        95390000
           IF PROXYL > 0 THEN                                           95400000
              MOVE PROXYI  TO CURRENT-PROXY                             95410000
              MOVE ZERO TO SPACE-COUNT                                  95420000
              INSPECT CURRENT-PROXY TALLYING SPACE-COUNT FOR ALL SPACES 95430000
              SUBTRACT SPACE-COUNT FROM LENGTH OF CURRENT-PROXY         95440000
                       GIVING PROXY-LEN.                                95450000
                                                                        95460000
           IF SYMBOLL > 0 THEN MOVE SYMBOLI TO STOCK-SYMBOL.            95470000
                                                                        95480000
      *                                                                 95490000
      * Output the current contents of the commarea on to the           95500000
      * screen and return with a commarea to continue the               95510000
      * pseudo-conversation.                                            95520000
      *                                                                 95530000
       SEND-MAP-AND-EXIT.                                               95540000
           MOVE CURRENT-URI     TO URIO.                                95550000
           MOVE CURRENT-PROXY   TO PROXYO.                              95560000
           MOVE STOCK-SYMBOL    TO SYMBOLO.                             95570000
           MOVE STOCK-QUOTE     TO QUOTEO.                              95580000
           MOVE STOCK-DATESTAMP TO DATEO.                               95590000
           MOVE STOCK-TIMESTAMP TO TIMEO.                               95600000
           IF SOAP-FAULT EQUAL 'Y' THEN                                 95610000
              STRING 'SOAP Fault:   ' FAULT-STRING                      95620000
                 DELIMITED BY SIZE INTO FAULTO                          95630000
              END-STRING                                                95640000
              STRING '     Details: ' FAULT-DETAIL                      95650000
                 DELIMITED BY SIZE INTO DETAILO                         95660000
              END-STRING                                                95670000
           ELSE MOVE SPACES TO FAULTO DETAILO                           95680000
           END-IF.                                                      95690000
                                                                        95700000
           EXEC CICS SEND MAP('SBOXM01') MAPSET('DFH0SBM')              95710000
                          ERASE END-EXEC.                               95720000
                                                                        95730000
           PERFORM SAVE-COMMAREA-IN-TSQUEUE.                            95740000
                                                                        95750000
           EXEC CICS RETURN TRANSID(EIBTRNID)                           95760000
                            COMMAREA(STATE-DATA)                        95770000
                            LENGTH(LENGTH OF STATE-DATA)                95780000
                            END-EXEC.                                   95790000
                                                                        95800000
      *                                                                 95810000
      * If the user has pressed the PF3 or CLEAR key,                   95820000
      * erase the screen and return without a commarea                  95830000
      * to terminate the pseudo-conversation.                           95840000
      * The commarea is saved in the SOAPBUBBLE tsqueue so it           95850000
      * can be resurrected later (in another pseudo-conversation).      95860000
      *                                                                 95870000
       CLEAR-SCREEN-AND-EXIT.                                           95880000
           PERFORM SAVE-COMMAREA-IN-TSQUEUE.                            95890000
           EXEC CICS SEND FROM(DFHNULL) LENGTH(1) ERASE END-EXEC.       95900000
           EXEC CICS RETURN END-EXEC.                                   95910000
                                                                        95920000
      *                                                                 95930000
      * Before exiting, always save the contents of the commarea        95940000
      * in the SOAPBUBBLE queue. This creates an extended pseudo-       95950000
      * conversational state.                                           95960000
      * (We could have used a BTS container for this too,               95970000
      *  but that would make this sample too complex).                  95980000
      *                                                                 95990000
       SAVE-COMMAREA-IN-TSQUEUE.                                        96000000
           MOVE 1 TO QUEUE-ITEM.                                        96010000
           EXEC CICS WRITEQ TS QNAME('SOAPBUBBLE')                      96020000
                               REWRITE ITEM(QUEUE-ITEM)                 96030000
                               FROM(STATE-DATA)                         96040000
                               END-EXEC.                                96050000
                                                                        96060000
      *                                                                 96070000
      * Increment the pointer being used to scan the terminal buffer    96080000
      * to point to the next character.                                 96090000
      *                                                                 96100000
       BUMP-ADDRESS.                                                    96110000
           SET TERM-DATA-PTR                                            96120000
            TO ADDRESS OF TERMINAL-CHAR(2).                             96130000
           SET ADDRESS OF TERMINAL-DATA                                 96140000
            TO TERM-DATA-PTR.                                           96150000
                                                                        96160000
      *---------------------------------------------------------------* 96170000
      *                                                               * 96180000
      * Here we compose the SOAP request body.                        * 96190000
      * We use the Document API for this.                             * 96200000
      *                                                               * 96210000
      *---------------------------------------------------------------* 96220000
       BUILD-SOAP-REQUEST-BODY.                                         96230000
                                                                        96240000
      * Create an empty document                                        96250000
                                                                        96260000
           EXEC CICS DOCUMENT CREATE DOCTOKEN(DOCUMENT-TOKEN) END-EXEC. 96270000
                                                                        96280000
      * Add STOCK-SYMBOL as a document symbol                           96290000
                                                                        96300000
           EXEC CICS DOCUMENT SET    DOCTOKEN(DOCUMENT-TOKEN)           96310000
                                     SYMBOL(STOCK-SYMBOL-NAME)          96320000
                                     VALUE(STOCK-SYMBOL)                96330000
                                     LENGTH(LENGTH OF STOCK-SYMBOL)     96340000
                                     END-EXEC.                          96350000
                                                                        96360000
      * Insert the SOAP body template into the document.                96370000
      * The current value of the STOCK-SYMBOL will be substituted       96380000
                                                                        96390000
           EXEC CICS DOCUMENT INSERT DOCTOKEN(DOCUMENT-TOKEN)           96400000
                                     TEMPLATE(TEMPLATE-NAME)            96410000
                                     DOCSIZE(DOCUMENT-SIZE)             96420000
                                     END-EXEC.                          96430000
                                                                        96440000
      * Get some storage in which to retrive the SOAP body document.    96450000
                                                                        96460000
           EXEC CICS GETMAIN SET(DOCUMENT-PTR)                          96470000
                             FLENGTH(DOCUMENT-SIZE)                     96480000
                             END-EXEC.                                  96490000
           SET ADDRESS OF SOAP-REQUEST-BODY TO DOCUMENT-PTR.            96500000
                                                                        96510000
      * Retrieve the document into the acquired storage.                96520000
                                                                        96530000
           EXEC CICS DOCUMENT RETRIEVE DOCTOKEN(DOCUMENT-TOKEN)         96540000
                              INTO(SOAP-REQUEST-BODY)                   96550000
                              LENGTH(DOCUMENT-SIZE)                     96560000
                              DATAONLY                                  96570000
                              END-EXEC.                                 96580000
                                                                        96590000
      ***************************************************************** 96600000
      *                                                               * 96610000
      * Create the necessary BTS environment for the SOAP pipeline    * 96620000
      * pipeline and then initiate it.                                * 96630000
      *                                                               * 96640000
      ***************************************************************** 96650000
       SCHEDULE-SOAP-PIPELINE.                                          96660000
      *                                                                 96670000
      * Create a unique process-id based on the netname, termid,        96680000
      * and the current abstime.                                        96690000
      *                                                                 96700000
           EXEC CICS ASSIGN NETNAME(PROCESS-NETNAME) END-EXEC.          96710000
           MOVE EIBTRMID TO PROCESS-TERMID.                             96720000
           EXEC CICS ASKTIME ABSTIME(CURRENT-ABSTIME) END-EXEC.         96730000
           MOVE CURRENT-MILLISECONDS TO PROCESS-SERIAL.                 96740000
                                                                        96750000
      *                                                                 96760000
      * Define the process.                                             96770000
      * The tranid is not really used but must refer to a defined       96780000
      * transaction such as CSAC.                                       96790000
      *                                                                 96800000
           EXEC CICS DEFINE PROCESS(PROCESS-NAME)                       96810000
                            PROCESSTYPE(PROCESS-TYPE)                   96820000
                            TRANSID(PROCESS-TRANID)                     96830000
                            PROGRAM('DFHWSRT ')                         96840000
                            NOCHECK                                     96850000
                            END-EXEC.                                   96860000
                                                                        96870000
      *                                                                 96880000
      * Specify the target URI                                          96890000
      *                                                                 96900000
           DISPLAY 'CURRENT-URI: ' CURRENT-URI(1 : URI-LEN).            96910000
           EXEC CICS PUT ACQACTIVITY CONTAINER(TARGET-URI)              96920000
                         FROM(CURRENT-URI) FLENGTH(URI-LEN)             96930000
                         END-EXEC.                                      96940000
                                                                        96950000
      *                                                                 96960000
      * If a proxy is specified, specify its URL                        96970000
      *                                                                 96980000
           IF PROXY-LEN > 0 THEN                                        96990000
              EXEC CICS PUT ACQPROCESS CONTAINER('PROXY-SERVER')        97000000
                            FROM(CURRENT-PROXY) FLENGTH(PROXY-LEN)      97010000
                            END-EXEC.                                   97020000
      *                                                                 97030000
      * Insert the SOAP request body as input to the pipeline           97040000
      * and release its storage                                         97050000
      *                                                                 97060000
           EXEC CICS PUT ACQACTIVITY CONTAINER(REQUEST-BODY)            97070000
                         FROM(SOAP-REQUEST-BODY) END-EXEC.              97080000
           EXEC CICS FREEMAIN DATA(SOAP-REQUEST-BODY) END-EXEC.         97090000
CA8J
CA8J  *
CA8J  * Set up the input parameters for Basic Authentication,
CA8J  * then PERFORM the Basic Authentication routine.
CA8J  *
CA8J  * This code must be customized to provide meaningful values
CA8J  * for the userid and password and their respective lengths.
CA8J  *
CA8J       MOVE 'CICSUSER' TO HTTPAUTH-USERID.
CA8J       MOVE 'SECRETBA' TO HTTPAUTH-PASSWORD.
CA8J       MOVE 8          TO HTTPAUTH-USERID-LENGTH.
CA8J       MOVE 8          TO HTTPAUTH-PASSWORD-LENGTH.
CA8J       PERFORM SETUP-BASIC-AUTHENTICATION.
      *                                                                 97100000
      * Link to the Web Services router process and                     97110000
      * wait for it to complete                                         97120000
      *                                                                 97130000
           EXEC CICS LINK ACQPROCESS END-EXEC.                          97140000
                                                                        97150000
           EXEC CICS CHECK ACQPROCESS                                   97160000
                           COMPSTATUS(PROCESS-STATUS)                   97170000
                           ABCODE(PROCESS-ABCODE)                       97180000
                           END-EXEC.                                    97190000
      *                                                                 97200000
      * Receive the SOAP response body from its container.              97210000
      *                                                                 97220000
           EXEC CICS GET ACQACTIVITY CONTAINER(RESPONSE-BODY)           97230000
                         SET(ADDRESS OF SOAP-RESPONSE-BODY)             97240000
                         FLENGTH(DOCUMENT-SIZE)                         97250000
                         END-EXEC.                                      97260000
                                                                        97270000
      *                                                                 97280000
      * After the SOAP response body has been received, we have to      97290000
      * parse it to extract the SYMBOL-QUOTE response                   97300000
      *                                                                 97310000
       PARSE-SOAP-RESPONSE-BODY.                                        97320000
           XML PARSE SOAP-RESPONSE-BODY                                 97330000
              PROCESSING PROCEDURE XML-HANDLER                          97340000
              ON EXCEPTION                                              97350000
                 DISPLAY 'XML DOCUMENT ERROR ' XML-CODE                 97360000
              NOT ON EXCEPTION                                          97370000
                 DISPLAY 'XML DOCUMENT SUCCESSFULLY PARSED'             97380000
           END-XML.                                                     97390000
           IF SOAP-FAULT EQUAL 'Y' THEN                                 97400000
              DISPLAY 'SOAP FAULT: ' FAULT-STRING                       97410000
              DISPLAY '   Details: ' FAULT-DETAIL                       97420000
              MOVE 'FFF' TO STOCK-QUOTE                                 97430000
           END-IF.                                                      97440000
      *                                                                 97450000
      * Exit the process                                                97460000
      *                                                                 97470000
       EXIT-PROCESS.                                                    97480000
           GOBACK.                                                      97490000
      ***************************************************************** 97500000
      *                                                                 97510000
      * The following section is executed as a callback routine         97520000
      * out of the XML PARSE statement above.                           97530000
      *                                                                 97540000
      ***************************************************************** 97550000
       XML-HANDLER SECTION.                                             97560000
           EVALUATE XML-EVENT                                           97570000
      *                                                                 97580000
      * Start of tag. Lowercase the tag name and isolate it from        97590000
      * any namespace qualifier which precedes a colon.                 97600000
      *                                                                 97620000
              WHEN 'START-OF-ELEMENT'                                   97640000
                 DISPLAY 'START ELEMENT TAG: <' XML-TEXT '>'            97660000
                 MOVE 'NNNNNN' TO ELEMENT-FLAGS                         97680000
                 MOVE ZERO TO TAG-SIZE                                  97700000
                 MOVE FUNCTION LOWER-CASE(XML-TEXT) TO TAG-NAME         97720000
                 INSPECT TAG-NAME(1 : LENGTH OF XML-TEXT)               97740000
                         TALLYING TAG-SIZE                              97760000
                         FOR CHARACTERS AFTER INITIAL ':'               97780000
                 IF TAG-SIZE EQUAL ZERO THEN                            97800000
                    MOVE LENGTH OF XML-TEXT TO TAG-SIZE                 97820000
                 ELSE                                                   97840000
                    COMPUTE I = 1 + LENGTH OF XML-TEXT - TAG-SIZE       97860000
                    MOVE TAG-NAME(I : TAG-SIZE)                         97880000
                      TO TAG-NAME(1 : TAG-SIZE)                         97900000
                 END-IF                                                 97920000
                 SUBTRACT TAG-SIZE FROM LENGTH OF TAG-NAME GIVING J     97940000
                 MOVE SPACES TO TAG-NAME(1 + TAG-SIZE : J)              97960000
      *                                                                 97980000
      * Determine which tag is being opened and set a flag accordingly  98000000
      *                                                                 98020000
                 EVALUATE TAG-NAME                                      98040000
                   WHEN 'fault'                                         98060000
                     MOVE 'Y' TO SOAP-FAULT                             98080000
                   WHEN 'faultstring'                                   98100000
                     MOVE 'Y' TO IN-FAULTSTRING                         98120000
                   WHEN 'detail'                                        98140000
                     MOVE 'Y' TO IN-DETAIL                              98160000
                   WHEN 'quote'                                         98180000
                     MOVE 'Y' TO IN-QUOTE                               98200000
                   WHEN 'date'                                          98220000
                     MOVE 'Y' TO IN-DATESTAMP                           98240000
                   WHEN 'time'                                          98260000
                     MOVE 'Y' TO IN-TIMESTAMP                           98280000
                 END-EVALUATE                                           98300000
      *                                                                 98320000
      * Check which tag the current content characters relate to,       98340000
      * and move XML-TEXT to the corresponding variable.                98360000
      *                                                                 98380000
              WHEN 'CONTENT-CHARACTERS'                                 98400000
                 DISPLAY 'CONTENT CHARACTERS: <' XML-TEXT '>'           98420000
                 EVALUATE 'Y'                                           98440000
                   WHEN IN-QUOTE                                        98460000
                     PERFORM EXTRACT-STOCK-QUOTE-VALUE                  98480000
                   WHEN IN-DATESTAMP                                    98500000
                     MOVE XML-TEXT TO STOCK-DATESTAMP                   98520000
                   WHEN IN-TIMESTAMP                                    98540000
                     MOVE XML-TEXT TO STOCK-TIMESTAMP                   98560000
                   WHEN IN-FAULTSTRING                                  98580000
                     MOVE XML-TEXT TO FAULT-STRING                      98600000
                   WHEN IN-DETAIL                                       98620000
                     MOVE XML-TEXT TO FAULT-DETAIL                      98640000
                 END-EVALUATE                                           98660000
              WHEN 'END-OF-ELEMENT'                                     98680000
                 DISPLAY 'END ELEMENT TAG: <' XML-TEXT '>'              98700000
              WHEN 'START-OF-DOCUMENT'                                  98720000
                 DISPLAY 'START OF DOCUMENT.'                           98740000
              WHEN 'END-OF-DOCUMENT'                                    98760000
                 DISPLAY 'END OF DOCUMENT.'                             98780000
              WHEN 'VERSION-INFORMATION'                                98800000
                 DISPLAY 'VERSION:<' XML-TEXT '>'                       98820000
              WHEN 'ENCODING-DECLARATION'                               98840000
                 DISPLAY 'ENCODING:<' XML-TEXT '>'                      98860000
              WHEN 'STANDALONE-DECLARATION'                             98880000
                 DISPLAY 'STANDALONE:<' XML-TEXT '>'                    98900000
              WHEN 'ATTRIBUTE-NAME'                                     98920000
                 DISPLAY 'ATTRIBUTE NAME:<' XML-TEXT '>'                98940000
              WHEN 'ATTRIBUTE-CHARACTERS'                               98960000
                 DISPLAY 'ATTRIBUTE VALUE CHARACTERS:<' XML-TEXT '>'    98980000
              WHEN 'ATTRIBUTE-CHARACTER'                                99000000
                 DISPLAY 'ATTRIBUTE VALUE CHARACTER:<' XML-TEXT '>'     99020000
              WHEN 'START-OF-CDATA-SECTION'                             99040000
                 DISPLAY 'START OF CDATA:<' XML-TEXT '>'                99060000
              WHEN 'END-OF-CDATA-SECTION'                               99080000
                 DISPLAY 'END OF CDATA:<' XML-TEXT '>'                  99100000
              WHEN 'CONTENT-CHARACTER'                                  99120000
                 DISPLAY 'CONTENT CHARACTER:<' XML-TEXT '>'             99140000
              WHEN 'PROCESSING-INSTRUCTION-TARGET'                      99160000
                 DISPLAY 'PI-TARGET:<' XML-TEXT '>'                     99180000
              WHEN 'PROCESSING-INSTRUCTION-DATA'                        99200000
                 DISPLAY 'PI-DATA:<' XML-TEXT '>'                       99220000
              WHEN 'COMMENT'                                            99240000
                 DISPLAY 'COMMENT:<' XML-TEXT '>'                       99260000
              WHEN 'EXCEPTION'                                          99280000
      *                                                                 99300000
      * XML-CODE 52 means that the code page being used does not match  99320000
      * the one specified in the document. This is expected since it    99340000
      * has been translated to EBCDIC since we received it.             99360000
      *                                                                 99380000
                 IF XML-CODE = 52 MOVE ZERO TO XML-CODE                 99400000
                 ELSE                                                   99420000
      *                                                                 99440000
      * An exception occurred during parsing                            99460000
      *                                                                 99480000
                   MOVE 'Y' TO PARSE-ERROR                              99500000
                 END-IF                                                 99520000
              WHEN OTHER                                                99540000
                 DISPLAY 'UNEXPECTED XML EVENT:' XML-EVENT '.'          99560000
                 MOVE 'Y' TO PARSE-ERROR                                99580000
           END-EVALUATE.                                                99600000
       XML-HANDLER-END. EXIT.                                           99620000
       XML-SUBROUTINES SECTION.                                         99640000
      *                                                                 99660000
      * The parser returns everything between the <Quote> and           99680000
      * </Quote> tags, including all whitespace (SP, CR, LF, NL, HT).   99700000
      * These are removed before saving the stock quote value.          99720000
      *                                                                 99740000
       EXTRACT-STOCK-QUOTE-VALUE.                                       99760000
           MOVE ZERO TO I J.                                            99780000
           MOVE LENGTH OF XML-TEXT TO L.                                99800000
           MOVE XML-TEXT TO WORKAREA(1 : L).                            99820000
           INSPECT WORKAREA(1 : L) CONVERTING X'0D251505' TO SPACES.    99840000
           INSPECT WORKAREA(1 : L) TALLYING I FOR LEADING SPACES.       99860000
           SUBTRACT I FROM L.                                           99880000
           INSPECT WORKAREA(I + 1 : L) TALLYING J FOR ALL SPACES.       99900000
           SUBTRACT J FROM L.                                           99920000
           IF L > LENGTH OF STOCK-QUOTE                                 99940000
                  MOVE LENGTH OF STOCK-QUOTE TO L.                      99960000
           MOVE WORKAREA(I + 1 : L) TO STOCK-QUOTE(1 : L).              99980000
CA8J  *
CA8J  * The following COPY statement copies the code that handles
CA8J  * Outbound Basic Authentication.
CA8J  * The specified copybook has already been translated with
CA8J  * The CICS Translator. If you are using the Intergrated
CA8J  * Translator, you can replace this with S4CBASIC, which
CA8J  * contains the untranslated EXEC statements.
CA8J  *
CA8J   COPY S4CBASIX.