      *----------------------------------------------------------------
      *
      *  Licensed Materials - Property of IBM
      *
      *  SupportPac CA8J
      *
      *  (C) Copyright IBM Corporation 2006    All Rights Reserved.
      *
      *  US Government Users Restricted Rights - Use, duplication
      *  or disclosure restricted by GSA ADP Schedule Contract
      *  with IBM Corporation
      *
      *----------------------------------------------------------------
      *
      * Set up the Basic Authentication header value
      *
       SETUP-BASIC-AUTHENTICATION SECTION.
           MOVE LENGTH OF BASIC-AUTH-VALUE TO BASIC-AUTH-VALUE-LENGTH.
           CALL 'HTTPAUTH' USING HTTPAUTH-FUNCTION
                           BASIC-AUTH-VALUE
                           BASIC-AUTH-VALUE-LENGTH
                           HTTPAUTH-USERID
                           HTTPAUTH-USERID-LENGTH
                           HTTPAUTH-PASSWORD
                           HTTPAUTH-PASSWORD-LENGTH.
      *
      * Get the current contents of the SOAPaction container,
      * or use a null string if none is present.
      *
           MOVE 'SOAP-ACTION' TO SOAPACTION-CONTAINER-NAME.
           MOVE SPACES TO SOAPACTION-CONTAINER.
           MOVE LENGTH OF SOAPACTION-CONTAINER
                       TO SOAPACTION-CONTAINER-SIZE.

           EXEC CICS GET CONTAINER(SOAPACTION-CONTAINER-NAME)
                         INTO(SOAPACTION-CONTAINER)
                         FLENGTH(SOAPACTION-CONTAINER-SIZE)
                         ACQACTIVITY
                         NOHANDLE END-EXEC.

           IF EIBRESP NOT EQUAL DFHRESP(NORMAL) THEN
              MOVE ZERO TO SOAPACTION-CONTAINER-SIZE.

      *
      * Pass the Basic Authentication header into the pipeline
      * by piggy-backing it on to the end of the SOAPaction header
      *
      * In the "SOAP for CICS" feature, the contents of the
      * SOAP-ACTION container are inserted between double quotes
      * that are already provided by the feature as the value of
      * the SOAPaction header.
      * To introduce an additional header, we have to close the
      * quoted string introduced by the feature, insert the desired
      * Authorization header, and then insert yet another header that
      * opens up another quoted string which the feature can close.
      *
      * That is, the feature will write out a "header" in the form
      *   SOAPaction: "zzzz";;
      * where zzzz is the contents of the SOAP-ACTION container
      * and ;; represents a CRLF pair, and we will introduce the
      * following into the container:
      *   ";;Authorization: Basic xxxxxx;;X-misc: "
      * where ;; represents a CRLF pair and xxxxxx represents
      * the Basic Authentication credential.
      *
      * Therefore, when the feature wraps this inside the SOAPaction
      * header, it creates the following sequence of three headers:
      *
      *   SOAPaction: "";;Authorization: Basic xxxxxx;;X-misc: "";;
      *                -----------------------------------------
      *
      * (The data that the feature obtains from the container
      *  is underlined.)
      *

           ADD LENGTH OF BASIC-AUTH-NAME TO BASIC-AUTH-VALUE-LENGTH
               GIVING SOAPACTION-APPEND-LENGTH.

           MOVE
             BASIC-AUTHENTICATION-HEADER(1 : SOAPACTION-APPEND-LENGTH)
             TO SOAPACTION-CONTAINER(SOAPACTION-CONTAINER-SIZE + 1
                                           : SOAPACTION-APPEND-LENGTH).

           ADD SOAPACTION-APPEND-LENGTH TO SOAPACTION-CONTAINER-SIZE.

           MOVE MISCELLANEOUS-HEADER
             TO SOAPACTION-CONTAINER(SOAPACTION-CONTAINER-SIZE + 1
                                     : LENGTH OF MISCELLANEOUS-HEADER).

           ADD LENGTH OF MISCELLANEOUS-HEADER
               TO SOAPACTION-CONTAINER-SIZE.

           EXEC CICS PUT CONTAINER(SOAPACTION-CONTAINER-NAME)
                         FROM(SOAPACTION-CONTAINER)
                         FLENGTH(SOAPACTION-CONTAINER-SIZE)
                         ACQACTIVITY
                         END-EXEC.